package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class ActorEvents_1 extends ActorScript
{
	public var _SkjoldAktivert:Bool;
	public var _HarSkjold:Bool;
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_AktiverSkjoldAnimasjon():Void
	{
		var __Self:Actor = actor;
		__Self.setAnimation("Skjold");
	}
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_DeaktiverSkjoldAnimasjon():Void
	{
		var __Self:Actor = actor;
		__Self.setAnimation("Standard");
	}
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("SkjoldAktivert", "_SkjoldAktivert");
		_SkjoldAktivert = false;
		nameMap.set("HarSkjold", "_HarSkjold");
		_HarSkjold = false;
		
	}
	
	override public function init()
	{
		
		/* ======================== Something Else ======================== */
		addCollisionListener(actor, function(event:Collision, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if(!((event.thisActor.say("Skjold Egenskap", "_customBlock_SkjoldAktivert") : Bool)))
				{
					event.otherActor.say("Helse Egenskap", "_customBlock_TilforSkade", [50]);
				}
				else
				{
					event.otherActor.say("Helse Egenskap", "_customBlock_TilforSkade", [5000]);
				}
			}
		});
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if(actor.isBehaviorEnabled("Auto Skyt"))
				{
					actor.say("Auto Skyt", "_customBlock_AutoSkytLaser");
				}
			}
		});
		
		/* ======================== Specific Actor ======================== */
		addWhenKilledListener(actor, function(list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				Engine.engine.setGameAttribute("Liv", ((Engine.engine.getGameAttribute("Liv") : Float) - 1));
				sayToScene("HUD", "_customBlock_FjernEkstraLivFraHUD");
				sayToScene("SceneEvents_0", "_customBlock_LeggSpillerTilScene");
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}