package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class ActorEvents_143 extends ActorScript
{
	public var _RekordAktor:Actor;
	public var _Tekst:String;
	public var _cx:Float;
	public var _cy:Float;
	public var _BoksOK:Region;
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("RekordAktor", "_RekordAktor");
		nameMap.set("Tekst", "_Tekst");
		_Tekst = "Yeah! Ny Rekord!!";
		nameMap.set("cx", "_cx");
		_cx = 0.0;
		nameMap.set("cy", "_cy");
		_cy = 0.0;
		nameMap.set("BoksOK", "_BoksOK");
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		/* "Sette senter (x, y) basert p~x00e5 TekstBoks plasseringen." */ _cx = ((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermBredde() : Float) + asNumber(actor.getValue("TekstBoks Egenskap", "_PosX")));
		_cy = ((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermHoyde() : Float) - asNumber(actor.getValue("TekstBoks Egenskap", "_PosY")));
		
		/* ========================= When Drawing ========================= */
		addWhenDrawingListener(null, function(g:G, x:Float, y:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				g.setFont(getFont(129));
				g.drawString("" + "YEAH! Ny Rekord!", _cx, (_cy - 30));
				g.drawString("" + "Tast inn ditt navn", _cx, (_cy - 10));
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}