package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;
import box2D.collision.shapes.B2Shape;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_19_19_HUD extends SceneScript
{
	public var _LivNode:BitmapWrapper;
	public var _LivGrafikk:BitmapWrapper;
	public var _LivGrafikkListe:Array<Dynamic>;
	public var _SkjoldNode:BitmapWrapper;
	public var _SkjoldBilde:BitmapData;
	public var _SkjoldCanvas:BitmapData;
	public var _TekstGameOver:String;
	public var _TekstProvIgjen:String;
	public var _TekstOK:String;
	public var _RegionOK:Region;
	public var _RegionOKMarkert:Bool;
	public var _dxliv:Float;
	public var _RekordBoks:Actor;
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_SettRekordAktor(__Aktor:Actor):Void
	{
		_RekordBoks = __Aktor;
	}
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_TegnEkstraLivPaaHud():Void
	{
		_LivGrafikk = new BitmapWrapper(new Bitmap(getExternalImage("ekstraliv.png")));
		_dxliv = ((_LivGrafikk.width/Engine.SCALE + (10 * Engine.SCALE)) * _LivGrafikkListe.length);
		attachImageToHUD(_LivGrafikk, Std.int((_LivNode.x/Engine.SCALE + _dxliv)), Std.int(_LivNode.y/Engine.SCALE));
		_LivGrafikkListe.push(_LivGrafikk);
	}
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_FjernEkstraLivFraHUD():Void
	{
		_LivGrafikk = scripts.Design_10_10_FellesBlokk._customBlock_ReturnerSisteGrafikk(_LivGrafikkListe);
		if(!(_LivGrafikk == null))
		{
			_LivGrafikkListe.remove(_LivGrafikk);
			removeImage(_LivGrafikk);
		}
	}
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_TegnSkjoldPaaHud():Void
	{
		clearImage(_SkjoldCanvas);
		drawImageOnImage(_SkjoldBilde, _SkjoldCanvas, 0, 0, BlendMode.ADD);
	}
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_FjernSkjoldFraHud():Void
	{
		clearImage(_SkjoldCanvas);
	}
	
	
	public function new(dummy:Int, dummy2:Engine)
	{
		super();
		nameMap.set("LivNode", "_LivNode");
		nameMap.set("LivGrafikk", "_LivGrafikk");
		nameMap.set("LivGrafikkListe", "_LivGrafikkListe");
		nameMap.set("SkjoldNode", "_SkjoldNode");
		nameMap.set("SkjoldBilde", "_SkjoldBilde");
		nameMap.set("SkjoldCanvas", "_SkjoldCanvas");
		nameMap.set("TekstGameOver", "_TekstGameOver");
		_TekstGameOver = "GAME OVER";
		nameMap.set("TekstProvIgjen", "_TekstProvIgjen");
		_TekstProvIgjen = "Vil Du Pr~x00f8ve Igjen?";
		nameMap.set("TekstOK", "_TekstOK");
		_TekstOK = "OK";
		nameMap.set("RegionOK", "_RegionOK");
		nameMap.set("RegionOKMarkert", "_RegionOKMarkert");
		_RegionOKMarkert = false;
		nameMap.set("dxliv", "_dxliv");
		_dxliv = 0.0;
		nameMap.set("RekordBoks", "_RekordBoks");
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		/* "Initialiserer grafikk og posisjon." */ _SkjoldBilde = getExternalImage("skjold.png");
		_SkjoldCanvas = newImage(32, 32);
		_SkjoldNode = new BitmapWrapper(new Bitmap(_SkjoldCanvas));
		attachImageToHUD(_SkjoldNode, 20, 40);
		_LivGrafikkListe = new Array<Dynamic>();
		_LivNode = new BitmapWrapper(new Bitmap(newImage(32, 32)));
		attachImageToHUD(_LivNode, 20, 20);
		createBoxRegion(((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermBredde() : Float) - 30), (getScreenHeight() - 110), 60, 40);
		_RegionOK = getLastCreatedRegion();
		_RekordBoks = null;
		/* "Tegner antall ekstra liv." */ for(index0 in 0...Std.int((Engine.engine.getGameAttribute("Liv") : Float)))
		{
			_customBlock_TegnEkstraLivPaaHud();
		}
		
		/* ========================= When Drawing ========================= */
		addWhenDrawingListener(null, function(g:G, x:Float, y:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				g.setFont(getFont(49));
				g.drawString("" + ("" + (Engine.engine.getGameAttribute("Poeng") : Float)), 20, (getScreenHeight() - 40));
				if((Engine.engine.getGameAttribute("GameOver") : Bool))
				{
					g.setFont(getFont(149));
					g.drawString("" + _TekstGameOver, ((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermBredde() : Float) - (scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvTekstBredde(_TekstGameOver, getFont(149)) : Float)), 150);
					g.setFont(getFont(129));
					g.drawString("" + _TekstProvIgjen, ((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermBredde() : Float) - (scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvTekstBredde(_TekstProvIgjen, getFont(129)) : Float)), (getScreenHeight() - 150));
					/* "Tegner boks OK for ~x00e5 starte spillet p~x00e5 nytt." */ if(_RegionOKMarkert)
					{
						g.fillColor = Utils.convertColor(Utils.getColorRGB(0,153,153));
						g.fillRoundRect(_RegionOK.getX(), _RegionOK.getY(), _RegionOK.getWidth(), _RegionOK.getHeight(), 5);
					}
					g.strokeColor = Utils.getColorRGB(255,0,0);
					g.strokeSize = 1;
					g.drawRoundRect(_RegionOK.getX(), _RegionOK.getY(), _RegionOK.getWidth(), _RegionOK.getHeight(), 5);
					g.drawString("" + _TekstOK, ((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermBredde() : Float) - (scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvTekstBredde(_TekstOK, getFont(129)) : Float)), (getScreenHeight() - 100));
				}
			}
		});
		
		/* ========================== On Region =========================== */
		addMouseOverActorListener(_RegionOK, function(mouseState:Int, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && 1 == mouseState)
			{
				_RegionOKMarkert = true;
			}
		});
		
		/* ========================== On Region =========================== */
		addMouseOverActorListener(_RegionOK, function(mouseState:Int, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && -1 == mouseState)
			{
				_RegionOKMarkert = false;
			}
		});
		
		/* ========================== On Region =========================== */
		addMouseOverActorListener(_RegionOK, function(mouseState:Int, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && 5 == mouseState)
			{
				if((hasValue(_RekordBoks)))
				{
					sayToScene("SceneEvents_0", "_customBlock_SettNyRekord", ["" + _RekordBoks.say("TekstBoks Egenskap", "_customBlock_ReturnerTekst")]);
				}
				saveGame("mySave", function(success:Bool):Void
				{
					/* Lagre rekordene. */
				});
				reloadCurrentScene(null, createCrossfadeTransition(2));
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}