package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_23_23_Skjold extends ActorScript
{
	public var _ErSkjoldAktivert:Bool;
	public var _SkjoldLengde:Float;
	public var _AktivSkjold:Float;
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_LeggTilSkjold():Void
	{
		var __Self:Actor = actor;
		_AktivSkjold = _SkjoldLengde;
	}
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_AktiverSkjold():Void
	{
		var __Self:Actor = actor;
		if(!(_ErSkjoldAktivert))
		{
			_ErSkjoldAktivert = true;
			__Self.say("ActorEvents_1", "_customBlock_AktiverSkjoldAnimasjon");
		}
	}
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_SkjoldAktivert():Bool
	{
		var __Self:Actor = actor;
		return _ErSkjoldAktivert;
	}
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_DeaktiverSkjold():Void
	{
		var __Self:Actor = actor;
		if(_ErSkjoldAktivert)
		{
			_ErSkjoldAktivert = false;
			__Self.say("ActorEvents_1", "_customBlock_DeaktiverSkjoldAnimasjon");
		}
	}
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("Actor", "actor");
		nameMap.set("ErSkjoldAktivert", "_ErSkjoldAktivert");
		_ErSkjoldAktivert = false;
		nameMap.set("SkjoldLengde", "_SkjoldLengde");
		_SkjoldLengde = 3.0;
		nameMap.set("AktivSkjold", "_AktivSkjold");
		_AktivSkjold = 0.0;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		_ErSkjoldAktivert = false;
		_AktivSkjold = _SkjoldLengde;
		_customBlock_AktiverSkjold();
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if(_ErSkjoldAktivert)
				{
					if((_AktivSkjold < 0))
					{
						_customBlock_DeaktiverSkjold();
					}
				}
			}
		});
		
		/* =========================== Keyboard =========================== */
		addKeyStateListener("Skjold", function(pressed:Bool, released:Bool, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && pressed)
			{
				if((Engine.engine.getGameAttribute("SkjoldTilgjengelig") : Bool))
				{
					Engine.engine.setGameAttribute("SkjoldTilgjengelig", false);
					_customBlock_LeggTilSkjold();
					_customBlock_AktiverSkjold();
					sayToScene("HUD", "_customBlock_FjernSkjoldFraHud");
				}
			}
		});
		
		/* ======================= Every N seconds ======================== */
		runPeriodically(1000 * 1, function(timeTask:TimedTask):Void
		{
			if(wrapper.enabled)
			{
				if(_ErSkjoldAktivert)
				{
					_AktivSkjold -= 1;
				}
			}
		}, actor);
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}