package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_36_36_TekstBoks extends ActorScript
{
	public var _Tekst:String;
	public var _Skrift:Font;
	public var _PosX:Float;
	public var _PosY:Float;
	public var _Prefiks:String;
	public var _MaksTegn:Float;
	public var _Aktiv:Bool;
	public var _Offset:Bool;
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_ReturnerTekst():String
	{
		var __Self:Actor = actor;
		return _Tekst;
	}
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("Actor", "actor");
		nameMap.set("Tekst", "_Tekst");
		_Tekst = "";
		nameMap.set("Skrift", "_Skrift");
		nameMap.set("PosX", "_PosX");
		_PosX = 0.0;
		nameMap.set("PosY", "_PosY");
		_PosY = 0.0;
		nameMap.set("Prefiks", "_Prefiks");
		_Prefiks = "";
		nameMap.set("MaksTegn", "_MaksTegn");
		_MaksTegn = 15.0;
		nameMap.set("Aktiv", "_Aktiv");
		_Aktiv = false;
		nameMap.set("Offset", "_Offset");
		_Offset = false;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		_Tekst = "";
		_Aktiv = false;
		runLater(1000 * 1, function(timeTask:TimedTask):Void
		{
			_Aktiv = true;
		}, actor);
		
		/* ========================= When Drawing ========================= */
		addWhenDrawingListener(null, function(g:G, x:Float, y:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if((hasValue(_Skrift)))
				{
					g.setFont(_Skrift);
				}
				if(_Offset)
				{
					g.drawString("" + ((_Prefiks) + (_Tekst)), ((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermBredde() : Float) + _PosX), ((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermHoyde() : Float) + _PosY));
				}
				else
				{
					g.drawString("" + ((_Prefiks) + (_Tekst)), _PosX, _PosY);
				}
			}
		});
		
		/* =========================== Any Key ============================ */
		addAnyKeyReleasedListener(function(event:KeyboardEvent, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				/* Koder:
8   = Slette knappen
13 = Enter knappen */
				if(_Aktiv)
				{
					if((event.keyCode == 8))
					{
						if(((_Tekst).length > 0))
						{
							_Tekst = (_Tekst).substring(0, ((_Tekst).length - 1));
						}
					}
					else if(((_Tekst).length <= _MaksTegn))
					{
						_Tekst = ((_Tekst) + (charFromCharCode(event.charCode)));
					}
				}
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}