package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_42_42_RekordEgenskap extends ActorScript
{
	public var _Prefiks:String;
	public var _Navn:String;
	public var _Poeng:Float;
	public var _PosX:Float;
	public var _PosY:Float;
	public var _Skrift:Font;
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_SettVerdier(__Prefiks:String, __Navn:String, __Poeng:Float, __PosX:Float, __PosY:Float):Void
	{
		var __Self:Actor = actor;
		_Prefiks = __Prefiks;
		_Navn = __Navn;
		_Poeng = __Poeng;
		_PosX = __PosX;
		_PosY = __PosY;
	}
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("Actor", "actor");
		nameMap.set("Prefiks", "_Prefiks");
		_Prefiks = "";
		nameMap.set("Navn", "_Navn");
		_Navn = "";
		nameMap.set("Poeng", "_Poeng");
		_Poeng = 0.0;
		nameMap.set("PosX", "_PosX");
		_PosX = 0.0;
		nameMap.set("PosY", "_PosY");
		_PosY = 0.0;
		nameMap.set("Skrift", "_Skrift");
		
	}
	
	override public function init()
	{
		
		/* ========================= When Drawing ========================= */
		addWhenDrawingListener(null, function(g:G, x:Float, y:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				g.setFont(_Skrift);
				g.drawString("" + _Prefiks, _PosX, _PosY);
				g.drawString("" + _Navn, (_PosX + 35), _PosY);
				if((_Poeng >= 0))
				{
					g.drawString("" + ("" + _Poeng), (_PosX + 35), (_PosY + 20));
				}
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}