package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;
import box2D.collision.shapes.B2Shape;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_44_44_Felles extends SceneScript
{
	public var _FiendeType:Float;
	public var _FiendeListe:Float;
	public var _px:Float;
	public var _py:Float;
	
	/* ===================== Global Custom Block ====================== */
	public static function _customBlock_PekAktorMotMaal(__Aktor:Actor, __Maal:Actor):Void
	{
		if(__Aktor.isAlive())
		{
			__Aktor.setAngle(Utils.RAD * ((scripts.Design_44_44_Felles._customBlock_GradFraAktorTilMaal(__Aktor, __Maal) : Float)));
		}
	}
	
	/* ===================== Global Custom Block ====================== */
	public static function _customBlock_GradFraAktorTilMaal(__Fra:Actor, __Til:Actor):Float
	{
		return Utils.DEG * (Math.atan2((__Til.getYCenter() - __Fra.getYCenter()), (__Til.getXCenter() - __Fra.getXCenter())));
	}
	
	/* ===================== Global Custom Block ====================== */
	public static function _customBlock_DistanseFraAktorTilMaal(__Fra:Actor, __Til:Actor):Float
	{
		return Math.sqrt((Math.pow((__Til.getXCenter() - __Fra.getXCenter()), 2) + Math.pow((__Til.getYCenter() - __Fra.getYCenter()), 2)));
	}
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_LagTekstBoks(__cx:Float, __cy:Float, __Tekst:String, __Skrift:Font):Region
	{
		createBoxRegion((scripts.Design_44_44_Felles._customBlock_SenterTekstBredde(__cx, __Tekst, __Skrift) : Float), (scripts.Design_44_44_Felles._customBlock_SenterTekstHoyde(__cy, __Skrift) : Float), __Skrift.getTextWidth(__Tekst)/Engine.SCALE, __Skrift.getHeight()/Engine.SCALE);
		return getLastCreatedRegion();
	}
	
	/* ===================== Global Custom Block ====================== */
	public static function _customBlock_SenterTekstBredde(__x:Float, __Tekst:String, __Skrift:Font):Float
	{
		return (__x - (scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvTekstBredde(__Tekst, __Skrift) : Float));
	}
	
	/* ===================== Global Custom Block ====================== */
	public static function _customBlock_SenterTekstHoyde(__y:Float, __Skrift:Font):Float
	{
		return (__y - (scripts.Design_10_10_FellesBlokk._customBlock_HalvHoydeTekst(__Skrift) : Float));
	}
	
	/* ===================== Global Custom Block ====================== */
	public static function _customBlock_SenterGrafikkBredde(__x:Float, __Grafikk:BitmapWrapper):Float
	{
		return (__x - (__Grafikk.width/Engine.SCALE / 2));
	}
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_LagFiende(__Type:ActorType, __maksAnimasjon:Float, __Lokasjon:Actor, __Maal:Actor):Void
	{
		createRecycledActor(__Type, __Lokasjon.getXCenter(), __Lokasjon.getYCenter(), Script.FRONT);
		getLastCreatedActor().setAnimation("" + randomInt(0, Std.int((__maksAnimasjon - 1))));
		if(!(__Maal == null))
		{
			scripts.Design_44_44_Felles._customBlock_PekAktorMotMaal(getLastCreatedActor(), __Maal);
		}
		else
		{
			getLastCreatedActor().setAngle(Utils.RAD * (randomInt(0, 360)));
		}
	}
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_LeggTilFiende(__Maal:Actor):Void
	{
		/* Tilfeldig fiende:
0 - Ingen
1 - Stor Meteor
2 - Medium Meteor */
		/* 3 - Romskip A (sakte)
4 - Romskip B (normal)
5 - Romskip C (rask) */
		_FiendeType = randomInt(0, Std.int(_FiendeListe));
		if((_FiendeType == 0))
		{
			_customBlock_LeggStorMeteorTilScene(__Maal);
		}
		else if((_FiendeType == 1))
		{
			_customBlock_LeggStorMeteorTilScene(__Maal);
		}
		else if((_FiendeType == 2))
		{
			_customBlock_LeggMediumMeteorTilScene(__Maal);
		}
		else if((_FiendeType == 3))
		{
			_customBlock_LeggTilRomskip(getActorType(80), __Maal);
		}
		else if((_FiendeType == 4))
		{
			_customBlock_LeggTilRomskip(getActorType(94), __Maal);
		}
		else if((_FiendeType == 5))
		{
			_customBlock_LeggTilRomskip(getActorType(96), __Maal);
		}
	}
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_LeggTilRomskip(__Type:ActorType, __Maal:Actor):Void
	{
		if(((Engine.engine.getGameAttribute("AntallRomskip") : Float) < (Engine.engine.getGameAttribute("MaksRomskip") : Float)))
		{
			_customBlock_LagFiende(__Type, 4, (scripts.Design_10_10_FellesBlokk._customBlock_TilfeldigAktorFraListe((Engine.engine.getGameAttribute("SpawnLokasjoner") : Array<Dynamic>)) : Actor), __Maal);
			getLastCreatedActor().setValue("Follow Target", "_TargetActor", __Maal);
			getLastCreatedActor().setValue("Face Target", "_TargetActor", __Maal);
			getLastCreatedActor().say("Romskip Egenskap", "_customBlock_SettSpiller", [__Maal]);
		}
	}
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_LeggMediumMeteorTilScene(__Maal:Actor):Void
	{
		if((randomInt(0, 100) < 50))
		{
			_customBlock_LagFiende(getActorType(31), 4, (scripts.Design_10_10_FellesBlokk._customBlock_TilfeldigAktorFraListe((Engine.engine.getGameAttribute("SpawnLokasjoner") : Array<Dynamic>)) : Actor), __Maal);
		}
		else
		{
			_customBlock_LagFiende(getActorType(53), 4, (scripts.Design_10_10_FellesBlokk._customBlock_TilfeldigAktorFraListe((Engine.engine.getGameAttribute("SpawnLokasjoner") : Array<Dynamic>)) : Actor), __Maal);
		}
		getLastCreatedActor().applyImpulseInDirection((Utils.DEG * getLastCreatedActor().getAngle()), randomInt(20, 80));
	}
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_LeggStorMeteorTilScene(__Maal:Actor):Void
	{
		if(((Engine.engine.getGameAttribute("AntallMeteorStor") : Float) < (Engine.engine.getGameAttribute("MaksMeteorStor") : Float)))
		{
			if((randomInt(0, 100) < 50))
			{
				_customBlock_LagFiende(getActorType(5), 4, (scripts.Design_10_10_FellesBlokk._customBlock_TilfeldigAktorFraListe((Engine.engine.getGameAttribute("SpawnLokasjoner") : Array<Dynamic>)) : Actor), __Maal);
			}
			else
			{
				_customBlock_LagFiende(getActorType(51), 4, (scripts.Design_10_10_FellesBlokk._customBlock_TilfeldigAktorFraListe((Engine.engine.getGameAttribute("SpawnLokasjoner") : Array<Dynamic>)) : Actor), __Maal);
			}
			getLastCreatedActor().applyImpulseInDirection((Utils.DEG * getLastCreatedActor().getAngle()), randomInt(20, 100));
		}
	}
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_VisRekorder(__PosX:Float, __PosY:Float):Void
	{
		createRecycledActor(getActorType(161), 0, 0, Script.FRONT);
		getLastCreatedActor().say("Rekord Egenskap", "_customBlock_SettVerdier", ["Rekorder", "", -1, __PosX, __PosY]);
		createRecycledActor(getActorType(161), 0, 0, Script.FRONT);
		getLastCreatedActor().say("Rekord Egenskap", "_customBlock_SettVerdier", ["(1)", (Engine.engine.getGameAttribute("RekordNavn1") : String), (Engine.engine.getGameAttribute("RekordPoeng1") : Float), __PosX, (__PosY + 20)]);
		createRecycledActor(getActorType(161), 0, 0, Script.FRONT);
		getLastCreatedActor().say("Rekord Egenskap", "_customBlock_SettVerdier", ["(2)", (Engine.engine.getGameAttribute("RekordNavn2") : String), (Engine.engine.getGameAttribute("RekordPoeng2") : Float), __PosX, (__PosY + 60)]);
		createRecycledActor(getActorType(161), 0, 0, Script.FRONT);
		getLastCreatedActor().say("Rekord Egenskap", "_customBlock_SettVerdier", ["(3)", (Engine.engine.getGameAttribute("RekordNavn3") : String), (Engine.engine.getGameAttribute("RekordPoeng3") : Float), __PosX, (__PosY + 100)]);
	}
	
	
	public function new(dummy:Int, dummy2:Engine)
	{
		super();
		nameMap.set("FiendeType", "_FiendeType");
		_FiendeType = 0.0;
		nameMap.set("FiendeListe", "_FiendeListe");
		_FiendeListe = 0.0;
		nameMap.set("px", "_px");
		_px = 0.0;
		nameMap.set("py", "_py");
		_py = 0.0;
		
	}
	
	override public function init()
	{
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}