package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_45_45_AutoPilot extends ActorScript
{
	public var _Destinasjon:Actor;
	public var _diff:Float;
	public var _dist:Float;
	public var _AktivRute:Bool;
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("Actor", "actor");
		nameMap.set("Destinasjon", "_Destinasjon");
		nameMap.set("diff", "_diff");
		_diff = 0.0;
		nameMap.set("dist", "_dist");
		_dist = 0.0;
		nameMap.set("AktivRute", "_AktivRute");
		_AktivRute = false;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		_Destinasjon = null;
		_AktivRute = false;
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if((!hasValue(_Destinasjon)))
				{
					_Destinasjon = (scripts.Design_10_10_FellesBlokk._customBlock_TilfeldigAktorFraListe((Engine.engine.getGameAttribute("SpawnLokasjoner") : Array<Dynamic>)) : Actor);
					scripts.Design_44_44_Felles._customBlock_PekAktorMotMaal(actor, _Destinasjon);
				}
				else
				{
					if(((scripts.Design_44_44_Felles._customBlock_DistanseFraAktorTilMaal(actor, _Destinasjon) : Float) > 5))
					{
						actor.setVelocity((scripts.Design_44_44_Felles._customBlock_GradFraAktorTilMaal(actor, _Destinasjon) : Float), 5);
						_AktivRute = true;
					}
					else
					{
						actor.setXVelocity(0);
						actor.setYVelocity(0);
						if(_AktivRute)
						{
							_AktivRute = false;
							runLater(1000 * 1, function(timeTask:TimedTask):Void
							{
								_Destinasjon = null;
							}, actor);
						}
					}
				}
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}