package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_46_46_AutoSkyt extends ActorScript
{
	public var _Fart:Float;
	public var _KanSkyte:Bool;
	public var _Maal:Actor;
	public var _LaserType:ActorType;
	public var _LaserLyd:Sound;
	public var _SkyteRate:Float;
	public var _SkyteSannsynlighet:Float;
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_AutoSkytLaser():Void
	{
		var __Self:Actor = actor;
		if((_KanSkyte && ((hasValue(_Maal)) && _Maal.isAlive())))
		{
			createRecycledActor(_LaserType, actor.getXCenter(), actor.getYCenter(), Script.FRONT);
			getLastCreatedActor().setVelocity((Utils.DEG * actor.getAngle()), _Fart);
			getLastCreatedActor().setAngle(Utils.RAD * ((Utils.DEG * actor.getAngle())));
			playSound(_LaserLyd);
			_KanSkyte = false;
		}
	}
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("Actor", "actor");
		nameMap.set("Fart", "_Fart");
		_Fart = 20.0;
		nameMap.set("KanSkyte", "_KanSkyte");
		_KanSkyte = false;
		nameMap.set("Maal", "_Maal");
		nameMap.set("Laser Type", "_LaserType");
		nameMap.set("Laser Lyd", "_LaserLyd");
		nameMap.set("SkyteRate", "_SkyteRate");
		_SkyteRate = 2.0;
		nameMap.set("SkyteSannsynlighet", "_SkyteSannsynlighet");
		_SkyteSannsynlighet = 50.0;
		
	}
	
	override public function init()
	{
		
		/* ======================= Every N seconds ======================== */
		runPeriodically(1000 * _SkyteRate, function(timeTask:TimedTask):Void
		{
			if(wrapper.enabled)
			{
				/* Vi gjøre at romskipet får tilfeldig skyte mulighter. */
				if((randomInt(0, 100) <= _SkyteSannsynlighet))
				{
					_KanSkyte = true;
				}
			}
		}, actor);
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}