package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;
import box2D.collision.shapes.B2Shape;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class SceneEvents_0 extends SceneScript
{
	public var _dx:Float;
	public var _dy:Float;
	public var _Spiller:Actor;
	public var _NyRekord:Bool;
	public var _RekordBoks:Actor;
	public var _RekordPoeng:Float;
	public var _RekordNavn:String;
	public var _RekordPoengKopi:Float;
	public var _RekordNavnKopi:String;
	public var _TekstGameOver:String;
	public var _TekstProvIgjen:String;
	public var _RegionOK:Region;
	public var _RegionOKMarkert:Bool;
	public var _TekstOK:String;
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_LeggSpillerTilScene():Void
	{
		_Spiller = null;
		if(((Engine.engine.getGameAttribute("Liv") : Float) > 0))
		{
			/* "Lag ny spiller s~x00e5 lenge man har mer liv." */ runLater(1000 * 1, function(timeTask:TimedTask):Void
			{
				createRecycledActor(getActorType(1), (scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermBredde() : Float), (scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermHoyde() : Float), Script.FRONT);
				_Spiller = getLastCreatedActor();
				/* "Deaktiver lyden slik at man kan spille av \"Game Over\" lyd istedenfor." */ if(((Engine.engine.getGameAttribute("Liv") : Float) == 1))
				{
					getLastCreatedActor().say("Helse Egenskap", "_customBlock_DeaktiverLyd");
				}
			}, null);
		}
		else
		{
			Engine.engine.setGameAttribute("GameOver", true);
			stopAllSounds();
			playSound(getSound(125));
			showCursor();
			/* "Sjekker om det er en ny rekord." */ if((_customBlock_SjekkNyRekord() : Bool))
			{
				createRecycledActor(getActorType(143), 0, 0, Script.FRONT);
				setValueForScene("HUD", "_RekordBoks", getLastCreatedActor());
			}
			sayToScene("Felles", "_customBlock_VisRekorder", [20, ((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermHoyde() : Float) - 40)]);
		}
	}
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_LeggTilPoeng(__poeng:Float):Void
	{
		Engine.engine.setGameAttribute("Poeng", ((Engine.engine.getGameAttribute("Poeng") : Float) + __poeng));
		/* "Sjekker skjold." */ /* Spiller får ekstra skjold etter oppnådd "SkjoldNivå" poeng. NB! Spiller kan kun ha et skjold om gangen. */
		if(((Engine.engine.getGameAttribute("Poeng") : Float) >= (Engine.engine.getGameAttribute("SkjoldStatus") : Float)))
		{
			if(!((Engine.engine.getGameAttribute("SkjoldTilgjengelig") : Bool)))
			{
				Engine.engine.setGameAttribute("SkjoldTilgjengelig", true);
				playSound(getSound(109));
				sayToScene("HUD", "_customBlock_TegnSkjoldPaaHud");
			}
			Engine.engine.setGameAttribute("SkjoldStatus", ((Engine.engine.getGameAttribute("SkjoldStatus") : Float) + (Engine.engine.getGameAttribute("SkjoldNivaa") : Float)));
		}
		/* "Sjekker niv~x00e5 p~x00e5 \"Romskip\". Maks er niv~x00e5 5." */ if(((Engine.engine.getGameAttribute("Poeng") : Float) >= (Engine.engine.getGameAttribute("RomskipStatus") : Float)))
		{
			if((asNumber(getValueForScene("Felles", "_FiendeListe")) < 5))
			{
				setValueForScene("Felles", "_FiendeListe", (asNumber(getValueForScene("Felles", "_FiendeListe")) + 1));
				Engine.engine.setGameAttribute("RomskipStatus", ((Engine.engine.getGameAttribute("RomskipStatus") : Float) + (Engine.engine.getGameAttribute("RomskipNivaa") : Float)));
				Engine.engine.setGameAttribute("MaksRomskip", ((Engine.engine.getGameAttribute("MaksRomskip") : Float) + 1));
			}
		}
		/* "Sjekker ekstra liv." */ if(((Engine.engine.getGameAttribute("Poeng") : Float) >= (Engine.engine.getGameAttribute("LivStatus") : Float)))
		{
			Engine.engine.setGameAttribute("LivStatus", ((Engine.engine.getGameAttribute("LivStatus") : Float) + (Engine.engine.getGameAttribute("LivNivaa") : Float)));
			Engine.engine.setGameAttribute("Liv", ((Engine.engine.getGameAttribute("Liv") : Float) + 1));
			playSound(getSound(108));
			/* "Spilleren f~x00e5r full helse." */ _Spiller.setValue("Helse Egenskap", "_Helse", 100);
			_Spiller.say("Helse Egenskap", "_customBlock_AktiverLyd");
			sayToScene("HUD", "_customBlock_TegnEkstraLivPaaHud");
		}
	}
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_SjekkNyRekord():Bool
	{
		if(((Engine.engine.getGameAttribute("Poeng") : Float) > (Engine.engine.getGameAttribute("RekordPoeng3") : Float)))
		{
			return true;
		}
		else if(((Engine.engine.getGameAttribute("Poeng") : Float) > (Engine.engine.getGameAttribute("RekordPoeng2") : Float)))
		{
			return true;
		}
		else if(((Engine.engine.getGameAttribute("Poeng") : Float) > (Engine.engine.getGameAttribute("RekordPoeng1") : Float)))
		{
			return true;
		}
		return false;
	}
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_SettNyRekord(__Navn:String):Void
	{
		_RekordPoeng = (Engine.engine.getGameAttribute("Poeng") : Float);
		_RekordNavn = __Navn;
		for(index0 in 0...3)
		{
			if((_RekordPoeng > (Engine.engine.getGameAttribute("RekordPoeng1") : Float)))
			{
				_RekordPoengKopi = (Engine.engine.getGameAttribute("RekordPoeng1") : Float);
				_RekordNavnKopi = (Engine.engine.getGameAttribute("RekordNavn1") : String);
				Engine.engine.setGameAttribute("RekordPoeng1", _RekordPoeng);
				Engine.engine.setGameAttribute("RekordNavn1", _RekordNavn);
				_RekordPoeng = _RekordPoengKopi;
				_RekordNavn = _RekordNavnKopi;
			}
			else if((_RekordPoeng > (Engine.engine.getGameAttribute("RekordPoeng2") : Float)))
			{
				_RekordPoengKopi = (Engine.engine.getGameAttribute("RekordPoeng2") : Float);
				_RekordNavnKopi = (Engine.engine.getGameAttribute("RekordNavn2") : String);
				Engine.engine.setGameAttribute("RekordPoeng2", _RekordPoeng);
				Engine.engine.setGameAttribute("RekordNavn2", _RekordNavn);
				_RekordPoeng = _RekordPoengKopi;
				_RekordNavn = _RekordNavnKopi;
			}
			else if((_RekordPoeng > (Engine.engine.getGameAttribute("RekordPoeng3") : Float)))
			{
				Engine.engine.setGameAttribute("RekordPoeng3", _RekordPoeng);
				Engine.engine.setGameAttribute("RekordNavn3", _RekordNavn);
			}
		}
	}
	
	
	public function new(dummy:Int, dummy2:Engine)
	{
		super();
		nameMap.set("dx", "_dx");
		_dx = 0.0;
		nameMap.set("dy", "_dy");
		_dy = 0.0;
		nameMap.set("Spiller", "_Spiller");
		nameMap.set("NyRekord", "_NyRekord");
		_NyRekord = false;
		nameMap.set("RekordBoks", "_RekordBoks");
		nameMap.set("RekordPoeng", "_RekordPoeng");
		_RekordPoeng = 0.0;
		nameMap.set("RekordNavn", "_RekordNavn");
		_RekordNavn = "";
		nameMap.set("RekordPoengKopi", "_RekordPoengKopi");
		_RekordPoengKopi = 0.0;
		nameMap.set("RekordNavnKopi", "_RekordNavnKopi");
		_RekordNavnKopi = "";
		nameMap.set("TekstGameOver", "_TekstGameOver");
		_TekstGameOver = "GAME OVER";
		nameMap.set("TekstProvIgjen", "_TekstProvIgjen");
		_TekstProvIgjen = "Vil Du Pr~x00f8ve Igjen?";
		nameMap.set("RegionOK", "_RegionOK");
		nameMap.set("RegionOKMarkert", "_RegionOKMarkert");
		_RegionOKMarkert = false;
		nameMap.set("TekstOK", "_TekstOK");
		_TekstOK = "OK";
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		Engine.engine.setGameAttribute("GameOver", false);
		Engine.engine.setGameAttribute("Poeng", 0);
		Engine.engine.setGameAttribute("AntallMeteorStor", 0);
		Engine.engine.setGameAttribute("AntallRomskip", 0);
		Engine.engine.setGameAttribute("Liv", 3);
		Engine.engine.setGameAttribute("MaksMeteorStor", 8);
		Engine.engine.setGameAttribute("MaksRomskip", 1);
		Engine.engine.setGameAttribute("LivNivaa", 8000);
		Engine.engine.setGameAttribute("SkjoldNivaa", 5000);
		Engine.engine.setGameAttribute("RomskipNivaa", 6500);
		Engine.engine.setGameAttribute("LivStatus", (Engine.engine.getGameAttribute("LivNivaa") : Float));
		Engine.engine.setGameAttribute("SkjoldStatus", (Engine.engine.getGameAttribute("SkjoldNivaa") : Float));
		Engine.engine.setGameAttribute("RomskipStatus", (Engine.engine.getGameAttribute("RomskipNivaa") : Float));
		Engine.engine.setGameAttribute("SkjoldTilgjengelig", false);
		Utils.clear((Engine.engine.getGameAttribute("SpawnLokasjoner") : Array<Dynamic>));
		hideCursor();
		for(actorOfType in getActorsOfType(getActorType(15)))
		{
			if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
				(Engine.engine.getGameAttribute("SpawnLokasjoner") : Array<Dynamic>).push(actorOfType);
				actorOfType.disableActorDrawing();
			}
		}
		_customBlock_LeggSpillerTilScene();
		loopSoundOnChannel(getSound(167), 1);
		setVolumeForChannel(70/100, 1);
		
		/* ======================= Every N seconds ======================== */
		runPeriodically(1000 * 3, function(timeTask:TimedTask):Void
		{
			if(wrapper.enabled)
			{
				sayToScene("Felles", "_customBlock_LeggTilFiende", [_Spiller]);
				if(getLastCreatedActor().hasBehavior("Auto Pilot"))
				{
					getLastCreatedActor().disableBehavior("Auto Pilot");
				}
			}
		}, null);
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}