package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;
import box2D.collision.shapes.B2Shape;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class SceneEvents_1 extends SceneScript
{
	public var _TittelGrafikk:BitmapWrapper;
	public var _Romskip:Actor;
	public var _FiendeListe:Float;
	public var _FiendeType:Float;
	public var _RegionStart:Region;
	public var _RegionAttribusjon:Region;
	public var _RegionStartMarkert:Bool;
	public var _TekstStart:String;
	public var _TekstAttribusjon:String;
	public var _RegionAttribusjonMarkert:Bool;
	
	
	public function new(dummy:Int, dummy2:Engine)
	{
		super();
		nameMap.set("TittelGrafikk", "_TittelGrafikk");
		nameMap.set("Romskip", "_Romskip");
		nameMap.set("FiendeListe", "_FiendeListe");
		_FiendeListe = 0.0;
		nameMap.set("FiendeType", "_FiendeType");
		_FiendeType = 0.0;
		nameMap.set("RegionStart", "_RegionStart");
		nameMap.set("RegionAttribusjon", "_RegionAttribusjon");
		nameMap.set("RegionStartMarkert", "_RegionStartMarkert");
		_RegionStartMarkert = false;
		nameMap.set("TekstStart", "_TekstStart");
		_TekstStart = "START";
		nameMap.set("TekstAttribusjon", "_TekstAttribusjon");
		_TekstAttribusjon = "ATTRIBUSJON";
		nameMap.set("RegionAttribusjonMarkert", "_RegionAttribusjonMarkert");
		_RegionAttribusjonMarkert = false;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		showCursor();
		loadGame("mySave", function(success:Bool):Void
		{
			/* Brukes til å laste inn rekorder. */
		});
		Engine.engine.setGameAttribute("AntallMeteorStor", 0);
		Engine.engine.setGameAttribute("AntallRomskip", 0);
		Engine.engine.setGameAttribute("MaksMeteorStor", 8);
		Engine.engine.setGameAttribute("MaksRomskip", 1);
		Utils.clear((Engine.engine.getGameAttribute("SpawnLokasjoner") : Array<Dynamic>));
		for(actorOfType in getActorsOfType(getActorType(15)))
		{
			if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
				(Engine.engine.getGameAttribute("SpawnLokasjoner") : Array<Dynamic>).push(actorOfType);
				actorOfType.disableActorDrawing();
			}
		}
		loopSoundOnChannel(getSound(168), 1);
		setVolumeForChannel(70/100, 1);
		_TittelGrafikk = new BitmapWrapper(new Bitmap(getExternalImage("tittel.png")));
		attachImageToHUD(_TittelGrafikk, Std.int((scripts.Design_44_44_Felles._customBlock_SenterGrafikkBredde((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermBredde() : Float), _TittelGrafikk) : Float)), 100);
		sayToScene("Felles", "_customBlock_VisRekorder", [((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermBredde() : Float) - 150), ((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermHoyde() : Float) - 40)]);
		/* "Lage knapper for start og attribusjon." */ _RegionStart = (sayToScene("Felles", "_customBlock_LagTekstBoks", [(scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermBredde() : Float), (getScreenHeight() - 100), _TekstStart, getFont(49)]) : Region);
		_RegionAttribusjon = (sayToScene("Felles", "_customBlock_LagTekstBoks", [(scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermBredde() : Float), (getScreenHeight() - 50), _TekstAttribusjon, getFont(49)]) : Region);
		/* "Vise kontroller konfigurasjonen." */ createRecycledActor(getActorType(161), 0, 0, Script.FRONT);
		getLastCreatedActor().say("Rekord Egenskap", "_customBlock_SettVerdier", ["Kontroller", "", -1, ((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermBredde() : Float) + 100), ((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermHoyde() : Float) - 40)]);
		createRecycledActor(getActorType(161), 0, 0, Script.FRONT);
		getLastCreatedActor().say("Rekord Egenskap", "_customBlock_SettVerdier", ["W", "Akselere", -1, ((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermBredde() : Float) + 100), ((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermHoyde() : Float) - 20)]);
		createRecycledActor(getActorType(161), 0, 0, Script.FRONT);
		getLastCreatedActor().say("Rekord Egenskap", "_customBlock_SettVerdier", ["A", "Snu til Venstre", -1, ((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermBredde() : Float) + 100), ((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermHoyde() : Float) + 0)]);
		createRecycledActor(getActorType(161), 0, 0, Script.FRONT);
		getLastCreatedActor().say("Rekord Egenskap", "_customBlock_SettVerdier", ["D", "Snu til H~x00f8yre", -1, ((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermBredde() : Float) + 100), ((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermHoyde() : Float) + 20)]);
		createRecycledActor(getActorType(161), 0, 0, Script.FRONT);
		getLastCreatedActor().say("Rekord Egenskap", "_customBlock_SettVerdier", ["Q", "Aktiver Skjold", -1, ((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermBredde() : Float) + 100), ((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermHoyde() : Float) + 40)]);
		createRecycledActor(getActorType(161), 0, 0, Script.FRONT);
		getLastCreatedActor().say("Rekord Egenskap", "_customBlock_SettVerdier", ["K", "Skyt", -1, ((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermBredde() : Float) + 100), ((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermHoyde() : Float) + 60)]);
		createRecycledActor(getActorType(161), 0, 0, Script.FRONT);
		getLastCreatedActor().say("Rekord Egenskap", "_customBlock_SettVerdier", ["MH", "(H~x00f8yre Mus Klikk)", -1, ((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermBredde() : Float) + 100), ((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermHoyde() : Float) + 80)]);
		createRecycledActor(getActorType(161), 0, 0, Script.FRONT);
		getLastCreatedActor().say("Rekord Egenskap", "_customBlock_SettVerdier", ["", "Skyt", -1, ((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermBredde() : Float) + 100), ((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermHoyde() : Float) + 100)]);
		
		/* ========================= When Drawing ========================= */
		addWhenDrawingListener(null, function(g:G, x:Float, y:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if(_RegionStartMarkert)
				{
					g.setFont(getFont(194));
				}
				else
				{
					g.setFont(getFont(49));
				}
				g.drawString("" + _TekstStart, _RegionStart.getX(), _RegionStart.getY());
				if(_RegionAttribusjonMarkert)
				{
					g.setFont(getFont(194));
				}
				else
				{
					g.setFont(getFont(49));
				}
				g.drawString("" + _TekstAttribusjon, _RegionAttribusjon.getX(), _RegionAttribusjon.getY());
			}
		});
		
		/* ======================= Every N seconds ======================== */
		runPeriodically(1000 * 3, function(timeTask:TimedTask):Void
		{
			if(wrapper.enabled)
			{
				sayToScene("Felles", "_customBlock_LeggTilFiende", [null]);
				if(getLastCreatedActor().hasBehavior("Auto Pilot"))
				{
					getLastCreatedActor().disableBehavior("Follow Target");
					getLastCreatedActor().disableBehavior("Face Target");
					getActor(18).setValue("Follow Target", "_TargetActor", getLastCreatedActor());
					getActor(18).setValue("Face Target", "_TargetActor", getLastCreatedActor());
					getActor(18).setValue("Auto Skyt", "_Maal", getLastCreatedActor());
				}
			}
		}, null);
		
		/* ========================== On Region =========================== */
		addMouseOverActorListener(_RegionStart, function(mouseState:Int, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && 1 == mouseState)
			{
				_RegionStartMarkert = true;
			}
		});
		
		/* ========================== On Region =========================== */
		addMouseOverActorListener(_RegionStart, function(mouseState:Int, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && -1 == mouseState)
			{
				_RegionStartMarkert = false;
			}
		});
		
		/* ========================== On Region =========================== */
		addMouseOverActorListener(_RegionStart, function(mouseState:Int, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && 5 == mouseState)
			{
				switchScene(GameModel.get().scenes.get(0).getID(), null, createCrossfadeTransition(2));
			}
		});
		
		/* ========================== On Region =========================== */
		addMouseOverActorListener(_RegionAttribusjon, function(mouseState:Int, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && 1 == mouseState)
			{
				_RegionAttribusjonMarkert = true;
			}
		});
		
		/* ========================== On Region =========================== */
		addMouseOverActorListener(_RegionAttribusjon, function(mouseState:Int, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && -1 == mouseState)
			{
				_RegionAttribusjonMarkert = false;
			}
		});
		
		/* ========================== On Region =========================== */
		addMouseOverActorListener(_RegionAttribusjon, function(mouseState:Int, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && 5 == mouseState)
			{
				switchScene(GameModel.get().scenes.get(2).getID(), null, createSlideRightTransition(1));
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}