package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;
import box2D.collision.shapes.B2Shape;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class SceneEvents_2 extends SceneScript
{
	public var _RegionTilbake:Region;
	public var _RegionTilbakeMarkert:Bool;
	public var _TekstTilbake:String;
	public var _TekstAttribusjon:String;
	public var _LogoGrafikk:BitmapWrapper;
	public var _TekstUtvikler:String;
	public var _RulleTekster:Array<Dynamic>;
	public var _RulleTekstIndeks:Float;
	public var _TekstDato:String;
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_Rulletekst(__x:Float, __y:Float, __Tekst:String, __Skrift:Font):Void
	{
		createRecycledActor(getActorType(206), (scripts.Design_44_44_Felles._customBlock_SenterTekstBredde(__x, __Tekst, __Skrift) : Float), __y, Script.FRONT);
		getLastCreatedActor().setValue("Rulle Tekst Egenskap", "_Bunn", (getScreenHeight() - 170));
		getLastCreatedActor().setValue("Rulle Tekst Egenskap", "_Tekst", __Tekst);
		getLastCreatedActor().setValue("Rulle Tekst Egenskap", "_Skrift", __Skrift);
	}
	
	
	public function new(dummy:Int, dummy2:Engine)
	{
		super();
		nameMap.set("RegionTilbake", "_RegionTilbake");
		nameMap.set("RegionTilbakeMarkert", "_RegionTilbakeMarkert");
		_RegionTilbakeMarkert = false;
		nameMap.set("TekstTilbake", "_TekstTilbake");
		_TekstTilbake = "TILBAKE";
		nameMap.set("TekstAttribusjon", "_TekstAttribusjon");
		_TekstAttribusjon = "ATTRIBUSJON";
		nameMap.set("LogoGrafikk", "_LogoGrafikk");
		nameMap.set("TekstUtvikler", "_TekstUtvikler");
		_TekstUtvikler = "T.Sang 'n3rd0x' Tran";
		nameMap.set("RulleTekster", "_RulleTekster");
		nameMap.set("RulleTekstIndeks", "_RulleTekstIndeks");
		_RulleTekstIndeks = 0.0;
		nameMap.set("TekstDato", "_TekstDato");
		_TekstDato = "11/04-2020 (v1.0.2)";
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		stopAllSounds();
		showCursor();
		_RegionTilbake = (sayToScene("Felles", "_customBlock_LagTekstBoks", [(scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermBredde() : Float), (getScreenHeight() - 50), _TekstTilbake, getFont(49)]) : Region);
		_LogoGrafikk = new BitmapWrapper(new Bitmap(getExternalImage("n3rd0x.png")));
		attachImageToHUD(_LogoGrafikk, Std.int((scripts.Design_44_44_Felles._customBlock_SenterGrafikkBredde((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermBredde() : Float), _LogoGrafikk) : Float)), (getScreenHeight() - 180));
		setOriginForImage(_LogoGrafikk, (_LogoGrafikk.width/Engine.SCALE / 2), (_LogoGrafikk.height/Engine.SCALE / 2));
		_RulleTekster = new Array<Dynamic>();
		_RulleTekstIndeks = 0;
		_RulleTekster.push("== GRAFIKK ==");
		_RulleTekster.push("Kenney.nl (http://kenney.nl)");
		_RulleTekster.push("   ");
		_RulleTekster.push("== MUSIKK ==");
		_RulleTekster.push("Eric Matyas (http://soundimage.org)");
		_RulleTekster.push("   ");
		_RulleTekster.push("== LYD ==");
		_RulleTekster.push("Kenney.nl (http://kenney.nl)");
		_RulleTekster.push("Michael Kurinnoy (http://opengameart.org)");
		_RulleTekster.push("   ");
		_RulleTekster.push("  ");
		
		/* ======================= Every N seconds ======================== */
		runPeriodically(1000 * 2, function(timeTask:TimedTask):Void
		{
			if(wrapper.enabled)
			{
				/* "Hvert sekund oppretter vi en rulletekst fra listen." */ _customBlock_Rulletekst((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermBredde() : Float), 120, "" + _RulleTekster[Std.int(_RulleTekstIndeks)], getFont(49));
				_RulleTekstIndeks += 1;
				if((_RulleTekstIndeks > (_RulleTekster.length - 1)))
				{
					_RulleTekstIndeks = 0;
				}
			}
		}, null);
		
		/* ======================= Every N seconds ======================== */
		runPeriodically(1000 * 1, function(timeTask:TimedTask):Void
		{
			if(wrapper.enabled)
			{
				spinImageBy(_LogoGrafikk, 10, 1, Easing.linear);
			}
		}, null);
		
		/* ========================= When Drawing ========================= */
		addWhenDrawingListener(null, function(g:G, x:Float, y:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if(_RegionTilbakeMarkert)
				{
					g.setFont(getFont(194));
				}
				else
				{
					g.setFont(getFont(49));
				}
				g.drawString("" + _TekstTilbake, _RegionTilbake.getX(), _RegionTilbake.getY());
				/* "Attribusjon." */ g.setFont(getFont(149));
				g.drawString("" + _TekstAttribusjon, (scripts.Design_44_44_Felles._customBlock_SenterTekstBredde((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermBredde() : Float), _TekstAttribusjon, getFont(149)) : Float), 100);
				g.setFont(getFont(49));
				g.drawString("" + _TekstUtvikler, (scripts.Design_44_44_Felles._customBlock_SenterTekstBredde((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermBredde() : Float), _TekstUtvikler, getFont(49)) : Float), (getScreenHeight() - 120));
				g.drawString("" + _TekstDato, (scripts.Design_44_44_Felles._customBlock_SenterTekstBredde((scripts.Design_10_10_FellesBlokk._customBlock_ReturnerHalvSkjermBredde() : Float), _TekstDato, getFont(49)) : Float), (getScreenHeight() - 100));
			}
		});
		
		/* ========================== On Region =========================== */
		addMouseOverActorListener(_RegionTilbake, function(mouseState:Int, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && 1 == mouseState)
			{
				_RegionTilbakeMarkert = true;
			}
		});
		
		/* ========================== On Region =========================== */
		addMouseOverActorListener(_RegionTilbake, function(mouseState:Int, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && -1 == mouseState)
			{
				_RegionTilbakeMarkert = false;
			}
		});
		
		/* ========================== On Region =========================== */
		addMouseOverActorListener(_RegionTilbake, function(mouseState:Int, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && 5 == mouseState)
			{
				switchScene(GameModel.get().scenes.get(1).getID(), null, createSlideLeftTransition(1));
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}